#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1900five4xi.py">
#<abstract4xi abstract = "fires to direction five and to distance 1900"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2five4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
# -------------------------------------------------------------------------------------------------
# SHOT2FIVE - COORDINATE SIGNS OF SHOOT2FIVE4XI: (X - ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------    
global shot2five19004xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2five19004xi = {
                1: '-1005x108y1608z',
                2: '-1012x1513y542z',
                3: '-1026x57y1598z',
                4: '-1029x1029y1219z',
                5: '-1036x910y1306z',
                6: '-1043x3y1587z',
                7: '-1091x982y1205z',
                8: '-1092x862y1292z',
                9: '-1093x1462y523z',
                10: '-1147x811y1278z',
                11: '-1150x931y1190z',
                12: '-1171x1407y505z',
                13: '-118x6y1896z',
                14: '-1198x757y1264z',
                15: '-1207x877y1175z',
                16: '-122x587y1802z',
                17: '-1247x1347y487z',
                18: '-1247x699y1250z',
                19: '-1261x819y1160z',
                20: '-1293x639y1235z',
                21: '-1312x757y1145z',
                22: '-1319x1284y468z',
                23: '-1336x575y1221z',
                24: '-134x1279y1398z',
                25: '-1360x693y1130z',
                26: '-1376x508y1206z',
                27: '-137x0y1895z',
                28: '-1388x1216y450z',
                29: '-1405x625y1115z',
                30: '-1412x439y1192z',
                31: '-1445x368y1177z',
                32: '-1446x555y1099z',
                33: '-1453x1144y431z',
                34: '-1473x294y1162z',
                35: '-1484x482y1084z',
                36: '-1498x218y1147z',
                37: '-1514x1069y413z',
                38: '-1517x406y1068z',
                39: '-1519x140y1132z',
                40: '-1547x328y1052z',
                41: '-1572x249y1036z',
                42: '-1572x991y394z',
                43: '-158x597y1796z',
                44: '-1593x167y1020z',
                45: '-1610x84y1004z',
                46: '-1616x64y1175z',
                47: '-1622x0y988z',
                48: '-1625x909y376z',
                49: '-1673x824y357z',
                50: '-1718x737y338z',
                51: '-1757x647y320z',
                52: '-1791x555y301z',
                53: '-1821x461y282z',
                54: '-1845x366y263z',
                55: '-1864x269y245z',
                56: '-1878x171y226z',
                57: '-1887x73y207z',
                58: '-194x605y1790z',
                59: '-202x1181y1474z',
                60: '-203x1284y1385z',
                61: '-208x1752y703z',
                62: '-22x7y1899z',
                63: '-232x611y1783z',
                64: '-266x1183y1462z',
                65: '-271x614y1777z',
                66: '-273x1285y1372z',
                67: '-300x1746y685z',
                68: '-311x615y1770z',
                69: '-332x1181y1450z',
                70: '-343x1282y1359z',
                71: '-351x613y1763z',
                72: '-392x609y1756z',
                73: '-393x1734y668z',
                74: '-398x1176y1437z',
                75: '-414x1275y1345z',
                76: '-41x11y1899z',
                77: '-434x602y1748z',
                78: '-464x1167y1425z',
                79: '-476x592y1741z',
                80: '-485x1264y1332z',
                81: '-485x1718y650z',
                82: '-4x1y1899z',
                83: '-518x579y1733z',
                84: '-531x1154y1412z',
                85: '-556x1249y1318z',
                86: '-560x563y1725z',
                87: '-576x1696y632z',
                88: '-57x561y1814z',
                89: '-597x1137y1399z',
                90: '-601x545y1717z',
                91: '-60x13y1898z',
                92: '-626x1230y1305z',
                93: '-642x523y1709z',
                94: '-663x1116y1386z',
                95: '-666x1669y614z',
                96: '-682x499y1701z',
                97: '-696x1207y1291z',
                98: '-722x472y1692z',
                99: '-728x1091y1373z',
                100: '-755x1637y596z',
                101: '-760x442y1683z',
                102: '-766x1179y1277z',
                103: '-792x1063y1360z',
                104: '-797x409y1675z',
                105: '-79x13y1898z',
                106: '-833x374y1666z',
                107: '-834x1148y1263z',
                108: '-843x1601y578z',
                109: '-855x1030y1347z',
                110: '-867x336y1656z',
                111: '-899x295y1647z',
                112: '-89x575y1808z',
                113: '-901x1112y1248z',
                114: '-917x994y1333z',
                115: '-928x1559y560z',
                116: '-929x252y1637z',
                117: '-957x206y1628z',
                118: '-966x1073y1234z',
                119: '-978x954y1320z',
                120: '-982x158y1618z',
                121: '-99x10y1897z'}
#"
#"/>

# ----------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire1900five4xi" usage = "target function for charge19004xi4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# ----------------------------------------------------------------------------------------------------------------
def fire1900five4xi(queue2five, consumer_channel2five, publisher_channel2five):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE1900FIVE4XIFIVE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE1900FIVE4XIFIVE4XI -  QUEUE2FIVE: ", queue2five)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE1900FIVE4XIFIVE4XI -  CONSUMER_CHANNEL2FIVE: ", consumer_channel2five)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE1900FIVE4XIFIVE4XI -  PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE1900FIVE4XIFIVE4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2five.put(shot2five19004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE1900FIVE4XIFIVE4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE1900FIVE4XIFIVE4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE1900FIVE4XIFIVE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2five8shot2five19004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2five8shot2five19004xi</nack2put4xi>" 
            
        publisher_channel2five.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE1900FIVE4XIFIVE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE1900FIVE4XIFIVE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2FIVE: ", publisher_channel2five, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE1900FIVE4XIFIVE4XI - RETURNING QUEUE OBJECT QUEUE2FIVE: ", queue2five, " - TIME: ", time4xi())  
        # 
            
    return queue2five    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1900five4xi.py                             
# -------------------------------------------------------------------------------------------------                